## openio-sds 3.2.3

=== events/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.events")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

include_directories(BEFORE . ..
		${CMAKE_CURRENT_BINARY_DIR}/..
		${CMAKE_CURRENT_BINARY_DIR}/../metautils/lib)

include_directories(AFTER
		${ZMQ_INCLUDE_DIRS})

link_directories(
		${ZMQ_LIBRARY_DIRS})


add_library(oioevents SHARED
	oio_events_queue.c
	oio_events_queue_buffer.c
	oio_events_queue_zmq.c
	oio_events_queue_beanstalkd.c)

set_target_properties(oioevents PROPERTIES SOVERSION ${ABI_VERSION})
target_link_libraries(oioevents metautils ${GLIB2_LIBRARIES} ${ZMQ_LIBRARIES})

install(TARGETS oioevents
		LIBRARY DESTINATION ${LD_LIBDIR}
		RUNTIME DESTINATION bin
		PUBLIC_HEADER DESTINATION include)

=== meta0v2/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.m0v2")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

include_directories(BEFORE . ..)

link_directories(
		${ZK_LIBRARY_DIRS}
		${SQLITE3_LIBRARY_DIRS})


add_library(meta0remote SHARED meta0_remote.c meta0_remote.h)
set_target_properties(meta0remote PROPERTIES SOVERSION ${ABI_VERSION})
target_link_libraries(meta0remote
		metautils
		${GLIB2_LIBRARIES})


add_library(meta0utils SHARED meta0_utils.c meta0_utils.h)
set_target_properties(meta0utils PROPERTIES SOVERSION ${ABI_VERSION})
target_link_libraries(meta0utils
		metautils gridcluster
		${GLIB2_LIBRARIES})


add_library(meta0v2 SHARED meta0_backend.h meta0_backend.c)
set_target_properties(meta0v2 PROPERTIES SOVERSION ${ABI_VERSION})
target_link_libraries(meta0v2
		meta0utils metautils gridcluster sqliterepo
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES})


add_executable(meta0_client meta0_client.c)
bin_prefix(meta0_client -meta0-client)
target_link_libraries(meta0_client gridcluster
		meta0remote meta0utils metautils server)


add_executable(meta0_init meta0_init.c)
bin_prefix(meta0_init -meta0-init)
target_link_libraries(meta0_init gridcluster
		meta0remote meta0utils metautils server)


#add_executable(meta0_backend_test meta0_backend_test.c)
#target_link_libraries(meta0_backend_test
#		meta0v2 metautils server sqliterepo)


add_executable(meta0_server
		meta0_gridd_dispatcher.c meta0_server.c)
bin_prefix(meta0_server -meta0-server)
target_link_libraries(meta0_server
		meta0v2 meta0utils
        metautils gridcluster server sqliterepo
		sqlxsrv
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES})

install(TARGETS meta0utils meta0remote meta0v2 meta0_server meta0_client meta0_init
		LIBRARY DESTINATION ${LD_LIBDIR}
		RUNTIME DESTINATION bin)

install(TARGETS meta0remote
		LIBRARY DESTINATION ${LD_LIBDIR}
		RUNTIME DESTINATION bin)

=== meta1v2/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.m1v2")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

include_directories(BEFORE . ..
		${JSONC_INCLUDE_DIRS})

link_directories(
		${JSONC_LIBRARY_DIRS}
		${ZK_LIBRARY_DIRS}
		${SQLITE3_LIBRARY_DIRS})

add_library(meta1v2 SHARED
		compound_types.c compound_types.h
		meta1_backend_internals.h
		meta1_backend.h
		meta1_backend.c
		meta1_backend_internals.c
		meta1_backend_services.c
		meta1_backend_properties.c
		meta1_backend_references.c
		meta1_prefixes.c meta1_prefixes.h
		internals.h internals_sqlite.h)

set_target_properties(meta1v2 PROPERTIES SOVERSION ${ABI_VERSION})
target_link_libraries(meta1v2
		metautils gridcluster sqliterepo
		meta0utils meta2v2remote meta0remote
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES})

add_library(meta1remote SHARED meta1_remote.c meta1_remote.h)
set_target_properties(meta1remote PROPERTIES SOVERSION ${ABI_VERSION})
target_link_libraries(meta1remote
		metautils
		${GLIB2_LIBRARIES})

add_executable(meta1_server meta1_gridd_dispatcher.c meta1_server.c)
bin_prefix(meta1_server -meta1-server)
target_link_libraries(meta1_server meta1v2
        meta0utils metautils gridcluster server sqliterepo
		sqlxsrv
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES})

add_executable(meta1_client meta1_client.c)
bin_prefix(meta1_client -meta1-client)
target_link_libraries(meta1_client metautils meta1remote)

install(TARGETS meta1v2 meta1_server meta1remote meta1_client
		LIBRARY DESTINATION ${LD_LIBDIR}
		RUNTIME DESTINATION bin)

=== meta2v2/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.m2v2")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

include_directories(BEFORE . ..
		${CMAKE_CURRENT_BINARY_DIR}
		${CMAKE_CURRENT_BINARY_DIR}/..
		${CMAKE_CURRENT_BINARY_DIR}/../metautils/lib)

include_directories(AFTER
		${JSONC_INCLUDE_DIRS}
		${LIBRAIN_INCLUDE_DIRS})

link_directories(
		${JSONC_LIBRARY_DIRS}
		${ZK_LIBRARY_DIRS}
		${SQLITE3_LIBRARY_DIRS}
		${LIBRAIN_LIBRARY_DIRS})

add_custom_command(
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/autogen.c ${CMAKE_CURRENT_BINARY_DIR}/autogen.h
	COMMAND ${PYTHON_EXECUTABLE}
	ARGS ${CMAKE_CURRENT_SOURCE_DIR}/m2gen.py ${CMAKE_CURRENT_BINARY_DIR}
	DEPENDS m2gen.py
)

add_library(meta2v2utils SHARED
		meta2_utils_lb.c
		meta2_utils_lb.h
		generic.c
		generic.h
		${CMAKE_CURRENT_BINARY_DIR}/autogen.c
		${CMAKE_CURRENT_BINARY_DIR}/autogen.h
		meta2_utils.c
		meta2_utils.h
		meta2_bean.c
		meta2_bean_utils.c
		meta2_bean.h
		meta2_macros.h
		meta2_dedup_utils.h
		meta2_dedup_utils.c
		meta2_utils_json_in.c
		meta2_utils_json_out.c
		meta2_utils_json.h
)

target_link_libraries(meta2v2utils
		metautils gridcluster sqliteutils
		${LIBRAIN_LIBRARIES}
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES} ${JSONC_LIBRARIES})

add_library(meta2v2remote SHARED
		meta2_macros.h
		meta2v2_remote.h
		meta2v2_remote.c)

target_link_libraries(meta2v2remote
		meta2v2utils metautils
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES})

add_library(meta2v2 SHARED
		${CMAKE_CURRENT_BINARY_DIR}/autogen.h generic.h
		meta2_utils.h
		meta2_macros.h
		meta2_backend.h
		meta2_backend.c)

target_link_libraries(meta2v2
		metautils sqliterepo
		meta2v2remote meta1remote meta0remote meta0utils
		meta2v2utils meta2v2remote
		sqlxsrv
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES})

add_executable(meta2_server
		meta2_gridd_dispatcher.c
		meta2_filters_extract.c
		meta2_filters_check.c
		meta2_filters_misc.c
		meta2_filters_action_url.c
		meta2_filters_action_container.c
		meta2_filters_action_content.c
		meta2_filter_context.c
		meta2_server.c)
bin_prefix(meta2_server -meta2-server)

target_link_libraries(meta2_server meta2v2
        hcresolve metautils gridcluster server
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES})

install(TARGETS meta2v2 meta2v2remote meta2_server meta2v2utils
		LIBRARY DESTINATION ${LD_LIBDIR}
		RUNTIME DESTINATION bin)

=== resolver/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.resolver")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

include_directories(BEFORE . ..)

include_directories(AFTER
		${CMAKE_CURRENT_BINARY_DIR}/..
		${CMAKE_CURRENT_BINARY_DIR}/../metautils/lib)

add_library(hcresolve SHARED
		hc_resolver.c)

target_link_libraries(hcresolve
		meta0remote meta1remote metautils gridcluster
		${GLIB2_LIBRARIES})

install(TARGETS hcresolve
		LIBRARY DESTINATION ${LD_LIBDIR}
		RUNTIME DESTINATION bin)

=== server/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.srv")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

include_directories(BEFORE . ..)

add_library(server SHARED
		internals.h
		slab.c slab.h
		network_server.c network_server.h
        transport_gridd.c transport_gridd.h)

set_target_properties(server PROPERTIES SOVERSION ${ABI_VERSION})

target_link_libraries(server
		metautils
		-lm ${GLIB2_LIBRARIES})

install(TARGETS server
		LIBRARY DESTINATION ${LD_LIBDIR}
		RUNTIME DESTINATION bin)

=== sqliterepo/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.sqlite")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

include_directories(BEFORE . ..
		${CMAKE_CURRENT_BINARY_DIR}/../metautils/lib)

include_directories(AFTER
		${ZK_INCLUDE_DIRS}
		${SQLITE3_INCLUDE_DIRS})

link_directories(
		${ZK_LIBRARY_DIRS}
		${SQLITE3_LIBRARY_DIRS})


add_library(sqliteutils SHARED rc.c sqlite_utils.c)

set_target_properties(sqliteutils PROPERTIES SOVERSION ${ABI_VERSION})
target_link_libraries(sqliteutils metautils
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES})

add_library(sqlitereporemote SHARED
		sqlx_remote.c
		sqlx_remote_ex.c
		replication_client.c)

set_target_properties(sqlitereporemote PROPERTIES SOVERSION ${ABI_VERSION})
target_link_libraries(sqlitereporemote metautils
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES})

add_library(sqliterepo SHARED
		gridd_client_pool.c
		synchro.c
		version.c
		cache.c
		hash.c
		replication.c
		election.c
		replication_dispatcher.c
		repository.c
		restoration.c
		zk_manager.c
		upgrade.c)

set_target_properties(sqliterepo PROPERTIES SOVERSION ${ABI_VERSION})
target_link_libraries(sqliterepo metautils
		sqlitereporemote sqliteutils
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES} ${ZK_LIBRARIES})

install(TARGETS sqliterepo sqliteutils sqlitereporemote
		LIBRARY DESTINATION ${LD_LIBDIR}
		RUNTIME DESTINATION bin)

=== sqlx/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.sqlx")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

include_directories(BEFORE . ..
		${CMAKE_CURRENT_BINARY_DIR}/..
		${CMAKE_CURRENT_BINARY_DIR}/../metautils/lib)

include_directories(AFTER
		${ZK_INCLUDE_DIRS}
		${SQLITE3_INCLUDE_DIRS})

link_directories(
		${ZK_LIBRARY_DIRS}
		${SQLITE3_LIBRARY_DIRS})


add_library(sqlxsrv SHARED sqlx_service.c)

set_target_properties(sqlxsrv PROPERTIES SOVERSION ${ABI_VERSION})
target_link_libraries(sqlxsrv
		server metautils gridcluster sqliterepo
		hcresolve meta0remote meta1remote
		server sqliterepo metautils gridcluster
		oioevents
		${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES})


add_library(oiosqlx SHARED sqlx_client.c)
set_target_properties(oiosqlx PROPERTIES
		PUBLIC_HEADER "sqlx_client.h"
		SOVERSION ${ABI_VERSION})
target_link_libraries(oiosqlx
		oiocore oiosds
		${GLIB2_LIBRARIES})

add_library(oiosqlx_local SHARED sqlx_client_local.c)
set_target_properties(oiosqlx_local PROPERTIES
		PUBLIC_HEADER "sqlx_client_local.h"
		SOVERSION ${ABI_VERSION})
target_link_libraries(oiosqlx_local
		oiosqlx ${GLIB2_LIBRARIES} ${SQLITE3_LIBRARIES})


add_library(oiosqlx_direct SHARED sqlx_client_direct.c)
set_target_properties(oiosqlx_direct PROPERTIES
		PUBLIC_HEADER "sqlx_client_direct.h"
		SOVERSION ${ABI_VERSION})
target_link_libraries(oiosqlx_direct
		oiosqlx sqlitereporemote ${GLIB2_LIBRARIES})


add_executable(tool_sqlx tool_sqlx.c)
bin_prefix(tool_sqlx -sqlx)
target_link_libraries(tool_sqlx
		oiocore oiosds oiosqlx_direct
		${GLIB2_LIBRARIES})

add_executable(sqlx_server sqlx_server.c)
bin_prefix(sqlx_server -sqlx-server)
target_link_libraries(sqlx_server
		sqlxsrv ${GLIB2_LIBRARIES})

install(TARGETS
			sqlx_server
			tool_sqlx
			sqlxsrv
			oiosqlx
			oiosqlx_direct
			oiosqlx_local
		LIBRARY DESTINATION ${LD_LIBDIR}
		RUNTIME DESTINATION bin
		PUBLIC_HEADER DESTINATION include)

=== tools/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.tools")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

include_directories(BEFORE ..)

add_executable(echo-server oio-echo-server.c)
bin_prefix(echo-server "-echo-server")
target_link_libraries(echo-server metautils server gridcluster ${GLIB2_LIBRARIES})

add_executable(oio-tool oio-tool.c)
bin_prefix(oio-tool -tool)
target_link_libraries(oio-tool metautils ${GLIB2_LIBRARIES})


set(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/.timestamp")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/oio-unlock-all.sh
        ${CMAKE_CURRENT_BINARY_DIR}/${EXE_PREFIX}-unlock-all.sh
        @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/oio-flush-all.sh
                ${CMAKE_CURRENT_BINARY_DIR}/${EXE_PREFIX}-flush-all.sh
        @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/oio-wait-scored.sh
        ${CMAKE_CURRENT_BINARY_DIR}/${EXE_PREFIX}-wait-scored.sh
        @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/oio-reset.sh
        ${CMAKE_CURRENT_BINARY_DIR}/${EXE_PREFIX}-reset.sh
        @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/oio-bootstrap.py
        ${CMAKE_CURRENT_BINARY_DIR}/${EXE_PREFIX}-bootstrap.py
        @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/oio-sds.pc.in
        ${CMAKE_CURRENT_BINARY_DIR}/oio-sds.pc
        @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/oio-test-config.py
        ${CMAKE_CURRENT_BINARY_DIR}/${EXE_PREFIX}-test-config.py
        @ONLY)

add_custom_command(OUTPUT ${OUTPUT}
                   COMMAND ${CMAKE_COMMAND} -E touch ${OUTPUT}
                   DEPENDS ${DEPS})

add_custom_target(tools ALL DEPENDS ${OUTPUT})

install(FILES
            ${CMAKE_CURRENT_BINARY_DIR}/oio-sds.pc
        DESTINATION ${PKGCONFIG_DIRECTORY}
        PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)

install(TARGETS
            echo-server
            oio-tool
        DESTINATION bin)

install(PROGRAMS
            zk-bootstrap.py
            zk-reset.py
            oio-wrap.sh
            oio-election-reset.py
            oio-election-smudge.py
            oio-election-dump.py
            ${CMAKE_CURRENT_BINARY_DIR}/${EXE_PREFIX}-unlock-all.sh
            ${CMAKE_CURRENT_BINARY_DIR}/${EXE_PREFIX}-flush-all.sh
            ${CMAKE_CURRENT_BINARY_DIR}/${EXE_PREFIX}-wait-scored.sh
            ${CMAKE_CURRENT_BINARY_DIR}/${EXE_PREFIX}-bootstrap.py
            ${CMAKE_CURRENT_BINARY_DIR}/${EXE_PREFIX}-test-config.py
            ${CMAKE_CURRENT_BINARY_DIR}/${EXE_PREFIX}-reset.sh
        DESTINATION bin)

=== cluster/lib/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.cluster.lib")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

include_directories(BEFORE . .. ../..)

add_library(gridcluster SHARED gridcluster.c)

set_target_properties(gridcluster PROPERTIES SOVERSION ${ABI_VERSION})

target_link_libraries(gridcluster
		metautils oiosds
		-lm ${GLIB2_LIBRARIES})

install(TARGETS gridcluster
	LIBRARY DESTINATION ${LD_LIBDIR}
	RUNTIME DESTINATION bin)

=== metautils/lib/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.utils")

include_directories(BEFORE . ../..
		${CMAKE_CURRENT_BINARY_DIR}/../..
		${CMAKE_CURRENT_BINARY_DIR})

link_directories(
		${ASN1C_LIBRARY_DIRS})

include_directories(AFTER
		${JSONC_INCLUDE_DIRS})

add_custom_command(
	OUTPUT
		NativeEnumerated.c NativeEnumerated.h
		NativeInteger.c NativeInteger.h
		OCTET_STRING.c OCTET_STRING.h
		PrintableString.c PrintableString.h
		BIT_STRING.c BIT_STRING.h
		BOOLEAN.c BOOLEAN.h
		INTEGER.c INTEGER.h
		REAL.c REAL.h
		asn_application.h asn_codecs.h asn_codecs_prim.c asn_codecs_prim.h asn_internal.h

		AddrInfo.c AddrInfo.h
		Message.c Message.h
		Meta0Info.c Meta0Info.h
		Meta0InfoSequence.c Meta0InfoSequence.h
		NamespaceInfo.c NamespaceInfo.h
		Parameter.c Parameter.h
		ParameterSequence.c ParameterSequence.h
		Score.c Score.h
		ServiceTag.c ServiceTag.h
		ServiceInfo.c ServiceInfo.h
		ServiceInfoSequence.c ServiceInfoSequence.h

		RowFieldType.c RowFieldType.h
		RowFieldValue.c RowFieldValue.h
		RowField.c RowField.h
		RowFieldSequence.c RowFieldSequence.h
		Row.c Row.h
		RowSet.c RowSet.h
		RowName.c RowName.h
		TableHeader.c TableHeader.h
		Table.c Table.h
		TableSequence.c TableSequence.h
		TableVersion.c TableVersion.h
		BaseVersion.c BaseVersion.h

		M2V2Alias.c M2V2Alias.h
		M2V2Bean.c M2V2Bean.h
		M2V2BeanSequence.c M2V2BeanSequence.h
		M2V2Chunk.c M2V2Chunk.h
		M2V2ContentHeader.c M2V2ContentHeader.h
		M2V2Property.c M2V2Property.h

	PRE_BUILD
	COMMAND ${ASN1C_EXECUTABLE} ${ASN1C_EXE_OPTS} -fcompound-names -fskeletons-copy ${CMAKE_CURRENT_SOURCE_DIR}/description.asn
	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/description.asn
	COMMENT "Generating asn1c types"
	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/description.asn
)

add_custom_command(
	OUTPUT expr.yacc.c expr.yacc.h
	COMMAND ${BISON_EXECUTABLE}
	ARGS -d -y -o expr.yacc.c ${CMAKE_CURRENT_SOURCE_DIR}/expr.yacc.y
)

add_custom_command(
	OUTPUT expr.lex.c
	COMMAND ${FLEX_EXECUTABLE}
	ARGS -s -oexpr.lex.c ${CMAKE_CURRENT_SOURCE_DIR}/expr.lex.l
	DEPENDS expr.yacc.c expr.yacc.h
)

#	ARGS -d -s -oexpr.lex.c ${CMAKE_CURRENT_SOURCE_DIR}/expr.lex.l

add_library(metautils SHARED
		metacomm.h
		metatypes.h
		metautils.h
		metautils_bits.h
		metautils_macros.h

		rrd.c rrd.h
		volume_lock.c volume_lock.h
		lb.c lb.h
		common_main.c common_main.h
		utils_syscall.c metautils_syscall.h
		lrutree.c lrutree.h tree.h
		storage_policy.c storage_policy.h
		expr.clean.c
		expr.eval.c
		expr.lex.c expr.yacc.c expr.yacc.h
		expr.h

		utils_containers.c metautils_containers.h
		utils_svc_policy.c metautils_svc_policy.h
		utils_errors.c metautils_errors.h
		utils_sockets.c metautils_sockets.h
		utils_strings.c metautils_strings.h
		utils_hashstr.c metautils_hashstr.h
		utils_resolv.c metautils_resolv.h
		utils_task.c metautils_task.h
		utils_addr_info.c
		utils_gba.c
		utils_kv.c
		utils_acl.c
		utils_l4v.c
		utils_m1url.c
		utils_meta0_info.c
		utils_metadata.c
		utils_namespace_info.c
		utils_service_info.c

		gridd_client.c gridd_client.h
		gridd_client_ext.c gridd_client_ext.h

		${CMAKE_CURRENT_BINARY_DIR}/NativeEnumerated.c
		${CMAKE_CURRENT_BINARY_DIR}/NativeEnumerated.h
		${CMAKE_CURRENT_BINARY_DIR}/NativeInteger.c
		${CMAKE_CURRENT_BINARY_DIR}/NativeInteger.h
		${CMAKE_CURRENT_BINARY_DIR}/OCTET_STRING.c
		${CMAKE_CURRENT_BINARY_DIR}/OCTET_STRING.h
		${CMAKE_CURRENT_BINARY_DIR}/PrintableString.c
		${CMAKE_CURRENT_BINARY_DIR}/PrintableString.h
		${CMAKE_CURRENT_BINARY_DIR}/BIT_STRING.c
		${CMAKE_CURRENT_BINARY_DIR}/BIT_STRING.h
		${CMAKE_CURRENT_BINARY_DIR}/BOOLEAN.c
		${CMAKE_CURRENT_BINARY_DIR}/BOOLEAN.h
		${CMAKE_CURRENT_BINARY_DIR}/INTEGER.c
		${CMAKE_CURRENT_BINARY_DIR}/INTEGER.h
		${CMAKE_CURRENT_BINARY_DIR}/REAL.c
		${CMAKE_CURRENT_BINARY_DIR}/REAL.h

		${CMAKE_CURRENT_BINARY_DIR}/asn_application.h
		${CMAKE_CURRENT_BINARY_DIR}/asn_codecs.h
		${CMAKE_CURRENT_BINARY_DIR}/asn_codecs_prim.c
		${CMAKE_CURRENT_BINARY_DIR}/asn_codecs_prim.h
		${CMAKE_CURRENT_BINARY_DIR}/asn_internal.h

		${CMAKE_CURRENT_BINARY_DIR}/AddrInfo.c
		${CMAKE_CURRENT_BINARY_DIR}/AddrInfo.h
		${CMAKE_CURRENT_BINARY_DIR}/Message.c
		${CMAKE_CURRENT_BINARY_DIR}/Message.h
		${CMAKE_CURRENT_BINARY_DIR}/Meta0Info.c
		${CMAKE_CURRENT_BINARY_DIR}/Meta0Info.h
		${CMAKE_CURRENT_BINARY_DIR}/Meta0InfoSequence.c
		${CMAKE_CURRENT_BINARY_DIR}/Meta0InfoSequence.h
		${CMAKE_CURRENT_BINARY_DIR}/NamespaceInfo.c
		${CMAKE_CURRENT_BINARY_DIR}/NamespaceInfo.h
		${CMAKE_CURRENT_BINARY_DIR}/Parameter.c
		${CMAKE_CURRENT_BINARY_DIR}/Parameter.h
		${CMAKE_CURRENT_BINARY_DIR}/ParameterSequence.c
		${CMAKE_CURRENT_BINARY_DIR}/ParameterSequence.h
		${CMAKE_CURRENT_BINARY_DIR}/Score.c
		${CMAKE_CURRENT_BINARY_DIR}/Score.h
		${CMAKE_CURRENT_BINARY_DIR}/ServiceInfo.c
		${CMAKE_CURRENT_BINARY_DIR}/ServiceInfo.h
		${CMAKE_CURRENT_BINARY_DIR}/ServiceInfoSequence.c
		${CMAKE_CURRENT_BINARY_DIR}/ServiceInfoSequence.h
		${CMAKE_CURRENT_BINARY_DIR}/ServiceTag.c
		${CMAKE_CURRENT_BINARY_DIR}/ServiceTag.h

		${CMAKE_CURRENT_BINARY_DIR}/RowFieldSequence.c
		${CMAKE_CURRENT_BINARY_DIR}/RowFieldSequence.h
		${CMAKE_CURRENT_BINARY_DIR}/RowFieldValue.c
		${CMAKE_CURRENT_BINARY_DIR}/RowFieldValue.h
		${CMAKE_CURRENT_BINARY_DIR}/RowFieldType.c
		${CMAKE_CURRENT_BINARY_DIR}/RowFieldType.h
		${CMAKE_CURRENT_BINARY_DIR}/RowField.c
		${CMAKE_CURRENT_BINARY_DIR}/RowField.h
		${CMAKE_CURRENT_BINARY_DIR}/Row.c
		${CMAKE_CURRENT_BINARY_DIR}/Row.h
		${CMAKE_CURRENT_BINARY_DIR}/RowSet.c
		${CMAKE_CURRENT_BINARY_DIR}/RowSet.h
		${CMAKE_CURRENT_BINARY_DIR}/RowName.c
		${CMAKE_CURRENT_BINARY_DIR}/RowName.h
		${CMAKE_CURRENT_BINARY_DIR}/TableHeader.c
		${CMAKE_CURRENT_BINARY_DIR}/TableHeader.h
		${CMAKE_CURRENT_BINARY_DIR}/Table.c
		${CMAKE_CURRENT_BINARY_DIR}/Table.h
		${CMAKE_CURRENT_BINARY_DIR}/TableSequence.c
		${CMAKE_CURRENT_BINARY_DIR}/TableSequence.h
		${CMAKE_CURRENT_BINARY_DIR}/TableVersion.c
		${CMAKE_CURRENT_BINARY_DIR}/TableVersion.h
		${CMAKE_CURRENT_BINARY_DIR}/BaseVersion.c
		${CMAKE_CURRENT_BINARY_DIR}/BaseVersion.h

		${CMAKE_CURRENT_BINARY_DIR}/M2V2BeanSequence.h
		${CMAKE_CURRENT_BINARY_DIR}/M2V2BeanSequence.c
		${CMAKE_CURRENT_BINARY_DIR}/M2V2Bean.h
		${CMAKE_CURRENT_BINARY_DIR}/M2V2Bean.c
		${CMAKE_CURRENT_BINARY_DIR}/M2V2Alias.h
		${CMAKE_CURRENT_BINARY_DIR}/M2V2Alias.c
		${CMAKE_CURRENT_BINARY_DIR}/M2V2Chunk.h
		${CMAKE_CURRENT_BINARY_DIR}/M2V2Chunk.c
		${CMAKE_CURRENT_BINARY_DIR}/M2V2ContentHeader.h
		${CMAKE_CURRENT_BINARY_DIR}/M2V2ContentHeader.c
		${CMAKE_CURRENT_BINARY_DIR}/M2V2Property.h
		${CMAKE_CURRENT_BINARY_DIR}/M2V2Property.c

		comm_message.c
		comm_converter.c
		comm_meta_reply.c
)

target_link_libraries(metautils
		oiocore
		${GLIB2_LIBRARIES} ${JSONC_LIBRARIES}
		${ASN1C_LIBRARIES}
		-lm)

add_executable(tool_sigfpe tool_sigfpe.c)
target_link_libraries(tool_sigfpe
		metautils
		${GLIB2_LIBRARIES})


install(TARGETS metautils
		LIBRARY DESTINATION ${LD_LIBDIR}
		RUNTIME DESTINATION bin
		PUBLIC_HEADER DESTINATION include)

=== rawx-apache2/src/CMakeLists.txt ===
add_definitions(-DG_LOG_DOMAIN="oio.rawx.httpd")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")

include_directories(BEFORE . ../..)

include_directories(AFTER
		${ATTR_INCLUDE_DIRS}
		${APACHE2_INCLUDE_DIRS}
		${APR_INCLUDE_DIRS}
		${LZO_INCLUDE_DIRS}
		${ZLIB_INCLUDE_DIRS}
		${ZMQ_INCLUDE_DIRS})

link_directories(
		${ATTR_LIBRARY_DIRS}
		${APACHE2_LIBRARY_DIRS}
		${APR_LIBRARY_DIRS}
		${LZO_LIBRARY_DIRS}
		${ZLIB_LIBRARY_DIRS})

add_library(mod_dav_rawx MODULE
		mod_dav_rawx.c
		mod_dav_rawx.h
		rawx_bucket.c
		rawx_bucket.h
		rawx_config.h
		rawx_config_stats.c
		rawx_config_utils.c
		rawx_internals.c
		rawx_internals.h
		rawx_properties.c
		rawx_repo_core.h
		rawx_repo_core.c
		rawx_repository.c
		rawx_req_info.c
		rawx_chunk_update.c
		rawx_event.c
		rawx_event.h)

set_target_properties(mod_dav_rawx PROPERTIES PREFIX "" SUFFIX .so)

target_link_libraries(mod_dav_rawx
		metautils rawx oioevents
		${APR_LIBRARIES} ${GLIB2_LIBRARIES}
		${ZLIB_LIBRARIES} ${LZO_LIBRARIES}
		${ZMQ_LIBRARIES})

install(TARGETS mod_dav_rawx
		LIBRARY DESTINATION ${APACHE2_MODULES_DIRS})

=== debian/changelog ===
openio-sds (3.2.3-1) xenial; urgency=medium

  * New release

 -- Romain Acciari <romain.acciari@openio.io>  Tue, 09 May 2017 09:49:07 +0000

openio-sds (3.2.2-1) xenial; urgency=medium

  * New release

 -- Romain Acciari <romain.acciari@openio.io>  Thu, 20 Apr 2017 07:56:47 +0000

openio-sds (3.2.0-1) xenial; urgency=medium

  * New release

 -- Romain Acciari <romain.acciari@openio.io>  Tue, 21 Feb 2017 10:51:05 +0000

openio-sds (3.1.3-1) xenial; urgency=medium

  * New release
  * Add python-concurrent.futures dependency

 -- Romain Acciari <romain.acciari@openio.io>  Fri, 03 Feb 2017 13:38:32 +0000

openio-sds (3.1.2-3) xenial; urgency=medium

  * Fix /var/lib/oio owner/group

 -- Romain Acciari <romain.acciari@openio.io>  Fri, 20 Jan 2017 10:48:05 +0000

openio-sds (3.1.2-2) xenial; urgency=medium

  * Fix log path owners and permissions

 -- Romain Acciari <romain.acciari@openio.io>  Wed, 18 Jan 2017 10:59:19 +0000

openio-sds (3.1.2-1) xenial; urgency=medium

  * Update to 3.1.2

 -- Romain Acciari <romain.acciari@openio.io>  Wed, 28 Dec 2016 18:04:23 +0000

openio-sds (3.0.1-2) xenial; urgency=medium

  * Add user creation at preinst

 -- Romain Acciari <romain.acciari@openio.io>  Wed, 30 Nov 2016 15:18:49 +0000

openio-sds (3.0.1-1) xenial; urgency=medium

  * New release

 -- Romain Acciari <romain.acciari@openio.io>  Mon, 31 Oct 2016 15:29:16 +0000

openio-sds (3.0.0-1) xenial; urgency=medium

  * New release

 -- Romain Acciari <romain.acciari@openio.io>  Thu, 20 Oct 2016 09:50:39 +0000

openio-sds (3.0.0~c1-1) xenial; urgency=medium

  * New release candidate

 -- Romain Acciari <romain.acciari@openio.io>  Fri, 30 Sep 2016 10:00:05 +0000

openio-sds (3.0.0~b3-1) xenial; urgency=medium

  * New beta release

 -- Romain Acciari <romain.acciari@openio.io>  Fri, 09 Sep 2016 14:40:47 +0000

openio-sds (3.0.0~b1-1) xenial; urgency=medium

  * New beta release

 -- Romain Acciari <romain.acciari@openio.io>  Fri, 22 Jul 2016 20:59:23 +0000

=== debian/control ===
Source: openio-sds
Section: unknown
Priority: optional
Maintainer: Romain Acciari <romain.acciari@openio.io>
Build-Depends:
 debhelper (>= 9)
 , cmake
 , libglib2.0-dev (>= 2.42)
 , libzookeeper-mt-dev (>= 3.4.5)
 , python-dev
 , python-setuptools
 , libzmq3-dev
 , libcurl4-gnutls-dev
 , libapreq2-dev (>= 1.2)
 , libsqlite3-dev (>= 3.7.11)
 , libattr1-dev (>= 2.4.32)
 , libevent-dev (>= 2.0)
 , apache2 (>= 2.2)
 , apache2-dev (>= 2.2)
 , liblzo2-dev (>= 2.0)
 , openio-gridinit
 , openio-asn1c (>= 0.9.27.1)
 , libdb-dev
 , libjson-c-dev (>= 0.12)
 , flex
 , bison
 , curl
 , python-pbr
Standards-Version: 3.9.5
Homepage: <insert the upstream URL, if relevant>
#Vcs-Git: git://anonscm.debian.org/collab-maint/openio-sds.git
#Vcs-Browser: http://anonscm.debian.org/?p=collab-maint/openio-sds.git;a=summary

Package: openio-sds
Architecture: any
Depends:
 ${shlibs:Depends}
 , ${misc:Depends}
 , python-xattr (>= 0.8.0) | python-pyxattr (>= 0.4.0)
 , python-eventlet (>= 0.15.2)
 , gunicorn (>= 19.4.5)
 , python-requests (>= 2.6.0)
 , python-flask
 , python-redis
 , apache2
 , libexpat1
 , openio-asn1c (>= 0.9.27.1)
 , libglib2.0-0 (>= 2.42)
 , zlib1g
 , libjson-c2 (>= 0.12)
 , python-zookeeper (>= 3.4.5)
 , libapr1 (>= 1.2)
 , libevent-2.0-5
 , liblzo2-2 (>= 2.0)
 , openio-gridinit
 , libdb5.3
 , python-pbr
 , python-yaml
 , python-plyvel
 , libsqlite3-0 (>= 3.7.11)
 , libleveldb1v5
 , python-simplejson (>= 2.0.9)
 , python-flask
 , python-eventlet
 , python-redis
 , cliff-tablib
 , python-cliff (>= 1.13)
 , python-tablib
 , python-pyeclib (>= 1.2.0)
 , python-concurrent.futures
Description: OpenIO Cloud Storage Solution
 OpenIO software storage solution is designed to handle PETA-bytes of
 data in a distributed way, data such as: images, videos, documents, emails,
 and any other personal unstructured data.
 OpenIO is a fork of Redcurrant, from Worldline by Atos.

Package: openio-sds-dbg
Architecture: any
Section: debug
Priority: extra
Depends:
    openio-sds (= ${binary:Version}),
    ${misc:Depends}
Description: debugging symbols for openio-sds
 OpenIO software storage solution is designed to handle PETA-bytes of
 data in a distributed way, data such as: images, videos, documents, emails,
 and any other personal unstructured data.
 OpenIO is a fork of Redcurrant, from Worldline by Atos.
 .
 This package contains the debugging symbols for openio-sds.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
DH_VERBOSE = 1
export DH_OPTIONS=-v
export DEB_BUILD_OPTIONS += nocheck
export PBR_VERSION=3.2.0
DESTDIR=$(CURDIR)/debian/openio-sds
PYTHON_SITELIB=$(python -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


# main packaging script based on dh7 syntax
%:
	dh $@ --buildsystem cmake

override_dh_auto_configure:
	dh_auto_configure --buildsystem cmake -- \
	-DCMAKE_BUILD_TYPE="Release" \
	-DCMAKE_INSTALL_PREFIX="/usr" \
	-DLD_LIBDIR="lib" \
	-DEXE_PREFIX="oio" \
	-DZK_LIBDIR="/usr/lib" \
	-DZK_INCDIR="/usr/include/zookeeper" \
	-DLZO_INCDIR="/usr/include/lzo" \
	-DAPACHE2_LIBDIR="/usr/lib/apache2" \
	-DAPACHE2_INCDIR="/usr/include/apache2" \
	-DLIBRAIN_LIBDIR="/usr/lib" \
	-DLIBRAIN_INCDIR="/usr/include" \
	-DSOCKET_OPTIMIZED=1

override_dh_auto_build:
	dh_auto_build --buildsystem cmake
	python setup.py build

override_dh_install:
	dh_install
	python setup.py install -O1 --skip-build --prefix=/usr --install-layout=deb --root $(DESTDIR)
	# Install OpenIO SDS directories
	mkdir -pv $(DESTDIR)/var/log/oio/sds \
		$(DESTDIR)/var/lib/oio/sds \
		$(DESTDIR)/etc/oio/sds \
		$(DESTDIR)/run/oio/sds



# debmake generated override targets
# This is example for Cmake (See http://bugs.debian.org/641051 )
#override_dh_auto_configure:
#       dh_auto_configure -- \
#

.PHONY: override_dh_strip
override_dh_strip:
	dh_strip --dbg-package=openio-sds-dbg

override_dh_auto_install:
	dh_auto_install --destdir=debian/openio-sds
